#!/usr/bin/python

""" 
	xrpm - version 2.2
		module menu.py
		
    Copyright (C) 1997, 1998  George A. Farris
        george@gmsys.com - www.gmsys.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""

import os
import sys
import findrpm

from help import Ghelp
from Tkinter import *
from rpm import Rpm
from string import split, find
from gmsgui import attention, listfile
from gui import GetDir, GetFtp
from ScrolledText import *

class Gmenu:

	def __init__(self):
		n = None
		
	def makeMenuBar(self):
		self.menubar = Frame(self, relief=RAISED, bd=2)
		self.menubar.pack(side=TOP, fill=X)
		self.fileMenu()
		self.groupMenu()
		self.optionMenu()
#		self.findMenu()
		self.helpMenu()
	
	def fileMenu(self):
		mbutton = Menubutton(self.menubar, text='File', underline=0)
		mbutton.pack(side=LEFT)
		menu = Menu(mbutton)
		menu.add_command(label='Open Directory', command=self.getdir)
		menu.add_command(label='Open FTP Site', command=self.getftpsite)
		menu.add_command(label='List Installed', command=self.getinstalled)
		menu.add_command(label='View Log File', command=self.getlogfile)
		menu.add_command(label='Exit...', command=self.quit)
		mbutton['menu'] = menu
		return mbutton

	def groupMenu(self):
		mainGroups = self.getMainGroups()	# search all the packages fro high level groups
		mbutton = Menubutton(self.menubar, text='Groups', underline=0)
		mbutton.pack(side=LEFT)
		self.gmenu = Menu(mbutton)
		for menugroup in mainGroups:
			self.gmenu.add_command(label=menugroup, command=lambda item=menugroup, f=self.getgroup: f(item))
		mbutton['menu'] = self.gmenu
		return mbutton
	
	def optionMenu(self):
		mbutton = Menubutton(self.menubar, text='Options', underline=0)
		mbutton.pack(side=LEFT)
		menu = Menu(mbutton)
		menu.add_checkbutton(label=' Enable Log ', variable=self.ConfigUseLog)
		menu.add_checkbutton(label=' Use TkMan  ', variable=self.ConfigUseTkman)
		menu.add_checkbutton(label=' Show Sizes  ', variable=self.ConfigShowSize, command=self.getinstalled)

		insmenu = Menu(menu)
		insmenu.add_checkbutton(label=' Force install ', variable=self.ConfigInForce)
		insmenu.add_checkbutton(label=' Install older package ', variable=self.ConfigInOldpackage)
		insmenu.add_checkbutton(label=' Replace other package files ', variable=self.ConfigInReplaceFiles)
		insmenu.add_checkbutton(label=' Replace already installed ', variable=self.ConfigInReplacePkgs)
		insmenu.add_checkbutton(label=' No script execute ', variable=self.ConfigInNoscripts)
		insmenu.add_checkbutton(label=' No dependency check ', variable=self.ConfigInNodeps)
		insmenu.add_checkbutton(label=' Exclude documentation ', variable=self.ConfigInExcludeDocs)
		insmenu.add_checkbutton(label=' Upgrade package ', variable=self.ConfigInUpgrade)
		insmenu.add_checkbutton(label=' Verbose install ', variable=self.ConfigInVerbose)
		insmenu.add_checkbutton(label=' Delete downloaded file ', variable=self.ConfigInDeleteDl)		
		menu.add_cascade(label=' Install ', menu=insmenu)

		rmmenu = Menu(menu)
		rmmenu.add_checkbutton(label=' No script execute ', variable=self.ConfigRmNoscripts)
		rmmenu.add_checkbutton(label=' No dependency check', variable=self.ConfigRmNodeps)
		rmmenu.add_checkbutton(label=' Verbose remove', variable=self.ConfigRmVerbose)				
		menu.add_cascade(label=' Remove ', menu=rmmenu)		

		menu.add_command(label=' Save Options ', command=self.saveOptions)
		mbutton['menu'] = menu
		return mbutton


		
#	def findMenu(self):
#		mbutton = Menubutton(self.menubar, text='Find', underline=0)
#		mbutton.pack(side=LEFT)
#		menu = Menu(mbutton)
#		menu.add_command(label=' Find ', command=self.findlist)
#		menu.add_command(label=' Find & Install ', command=self.findinstall)
#		menu.add_command(label=' Find & Download ', command=self.finddownload)
#		mbutton['menu'] = menu
#		return mbutton

	def helpMenu(self):
		h = Ghelp()		# make a instance of help
		mbutton = Menubutton(self.menubar, text='Help', underline=0)
		mbutton.pack(side=RIGHT)
		menu = Menu(mbutton)
		menu.add_command(label=' About  ', command=h.about)
		menu.add_command(label=' Manual  ', command=h.help)
		menu.add_command(label=' License ', command=h.license)
		mbutton['menu'] = menu
		return mbutton

	def getMainGroups(self):
		glist = []
		i = 0
		s = os.popen('rpm  -qa  --queryformat "%{GROUP}\n"').readlines()
		for s1 in s:
			maingroup = split(s1,'/')[0]	# get the first group in the path
			if maingroup[-1:] == '\n':		# remove any newlines
				glist.append(maingroup[0:-1])
			else:
				glist.append(maingroup)
		glist.sort()
		mlist = []

		last = ''				# lets remove all the duplicates
		for current in glist:
			if current != last:
				mlist.append(current)
				last = current

		return mlist
